#ifndef BSTDARG_H
#define BSTDARG_H

typedef char *va_list;

#define __va_rounded_size(TYPE)  \
  (((sizeof (TYPE) + sizeof (int) - 1) / sizeof (int)) * sizeof (int))

#define va_start(VAR, LASTARG)                                          \
         (VAR = ((char *) &(LASTARG) + __va_rounded_size (LASTARG)))

#define va_end(x)

#define va_arg(VAR, TYPE)                                               \
         (VAR += __va_rounded_size (TYPE),                              \
	          *((TYPE *) (VAR - __va_rounded_size (TYPE))))
#endif
