/**************************/
/* process.h              */
/**************************/
/* Fichier d'en tte pour */
/* la LibB - Barbux       */
/**************************/
/* Attention! Ne peut pas */
/* tre excut sous      */
/* Linux                  */
/**************************/



/* Ce fichier d'en tte gre les appels systmes relatifs  la gestion de process */


// Excute l'executable dans la console correspondante
int exec(char * file, int console); // Appel systme n41

// Termine proprement un processus
int quit(); // Appel systme n42

// Tue un processus. Seul uid0 peut tuer un process d'uid differente
int kill(int uid); // Appel systme n43

// Donne l'ordre au processus de patienter sec secondes
int sleep(int sec); // Appel systme n44

// Donne l'ordre au processus de patienter usec micro-secondes
int usleep(int usec); // Appel systme n45

// Renvoie la dernire erreur gnre par le process
int geterreur(char * erreur); // Appel systme n46

// Renvoie le numro du processus
int getpid(); // Appel systme n47

// renvoie l'identifiant de l'utilisateur possedant le processus
int getuid(); // Appel systme n48

// Change l'identifiant de l'utilisateur.
int setuid(int uid); // Appel systme n49

// Permet d'ajouter incr  la priorit du process
int addpriority(int incr); // Appel systme n50


