// Gestion de console
#include "../include/console.h"

// Envoie un caractre  la position courante dans la console courante
void putchar(char c)
{
#ifdef FAKE
  write(1, &c, 1);
#else
  sys_putchar(c);
#endif
}

// Envoie le prochain caractre situ dans le buffer clavier de la console courante
char getchar()
{
#ifdef FAKE
  char c;
  read(0, &c, 1);
  return c;
#else
  sys_getchar();
#endif
}

// Cr une nouvelle console. Renvoie l'identifiant de la console
// $$ paramtre numro d'cran???
int console_create()
{
#ifdef FAKE
  return 0;
#else
  sys_console_create();
#endif
}
