/* Fichier d entree dans le kernel
 * C est par ici que le system repasse en mode systeme
 */

.text
.globl switch_task,floppy_interrupt,system_call,asm_invalid_opcode,clavier,switch_task_2

saveax:
.long 0
savebx:
.long 0
savecx:
.long 0
savecr3:
.long 0


str1:
.ascii "hello world %d"
.long 0
str2:
.ascii "Clavier"
.long 0

#define PUSHALL push %ds ;\
    push %es ;\
    push %fs ;\
    push %gs ;\
 \
    pushl %ebp ;\
    pushl %esi ;\
    pushl %edi ;\
;\
    pushl %eax ;\
    movl savecr3,%eax ;\
    pushl %eax ;\
    pushl %edx ;\
    pushl %ecx ;\
    pushl %ebx

#define PUSHALL2 push %ds ;\
    push %es ;\
    push %fs ;\
    push %gs ;\
 \
    pushl %ebp ;\
    pushl %esi ;\
    pushl %edi ;\
;\
    pushl %eax ;\
    movl %cr3,%eax ;\
    pushl %eax ;\
    pushl %edx ;\
    pushl %ecx ;\
    pushl %ebx



#define POPALL popl %ebx ;\
    popl %ecx ;\
    popl %edx ;\
    popl %eax ;\
    movl %eax,%cr3 ;\
;\
    popl %eax ;\
    popl %edi ;\
    popl %esi ;\
    popl %ebp ;\
    pop %gs ;\
    pop %fs ;\
    pop %es ;\
    pop %ds

#define KERSEG \ 
    pushl %eax ;\
    movw $0x18, %ax ;\
    movw %ax, %ds ;\
    movw %ax, %es ;\
    movw %ax, %fs ;\
    movw %ax, %gs ;\
    popl %eax
    

h:
    pushl %eax
    movl $str1,%eax
    pushl %eax
    call printk
    popl %eax
    popl %eax
    ret

switch_task:
    
    incl jiffies
    
switch_task_2:
    
    pushl %eax
    pushl %ebx
    movl %cr3,%eax
    movl %eax,savecr3
    movl $0x1000,%eax
    movl %eax,%cr3
    
//    movw $0x18,%ax
//    movw %ax,%ds
   
   
    movl $0, reschedule
    
    movl current, %eax
    movl (%eax),%ebx
    cmpl $100,%ebx
    jge suite

    popl %ebx
    popl %eax

    movl %eax,saveax
    movl %ebx,savebx

    movl %esp,%eax
    movl %ss,%ebx
    movl %ecx, savecx
    movl pilesys,%ecx
    movl %ecx,%esp
    movl $0x18,%ecx
    movl %ecx,%ss
    movl savecx ,%ecx
    
    pushl %ebx
    pushl %eax
    movl 8(%eax),%ebx
    pushl %ebx
    movl 4(%eax),%ebx
    pushl %ebx
    movl (%eax),%ebx
    pushl %ebx
    
    movl saveax,%eax
    movl savebx,%ebx


    PUSHALL
    
    call do_switch_task   //;pour les process user
    
  
    movl current, %eax
    movl (%eax),%ebx
    cmpl $100,%ebx
    jl suite11

    
    jmp suite12

suite11:

    POPALL

    movl %ebx,savebx
    movl %eax,saveax
    movl 12(%esp), %eax
    popl %ebx
    movl %ebx,(%eax)
    popl %ebx
    movl %ebx,4(%eax)
    popl %ebx
    movl %ebx,8(%eax)
    popl %eax
    popl %ebx
    movl %eax,%esp
    movl %ebx,%ss
	
    
    movl saveax,%eax
    movl savebx,%ebx

    iret
    


suite:
    popl %ebx
    popl %eax
  

    PUSHALL
  
    KERSEG
   
    call do_switch_task     //; pour les process user
    
  
    movl current, %eax
    movl (%eax),%ebx
    cmpl $100,%ebx
    jl suite11 
  
suite12:    
    
    POPALL

    cmpl $1,resystem
    je system_call   //; seul les users font des appels systemes bloquants
    
    iret
    
fin_switch_task:
    
floppy_interrupt:
    
    PUSHALL2
    
    KERSEG
    
    call irq6              
    
    POPALL
    
    iret

system_call:
    cli 
    
    movl $0 , process_en_attente
    movl $0 , resystem
   
    push %ds 
    push %es 
    push %fs
    push %gs 

    pushl %ebp 
    pushl %esi 
    pushl %edi 
    
    push %eax
    push %edx
    push %ecx
    push %ebx

    KERSEG

    shl $2,%eax
    addl $system_calls,%eax
    cmpl $system_calls,%eax     # ici on verifie que l appel systeme demande est valide
    jl 1f
    cmpl $fin_system_calls,%eax
    jge 1f
    movl (%eax),%eax
    call *%eax   # facon interessante de gerer les interruptions
    
2:    
    
    popl %edi
    popl %edi
    popl %edi
    popl %edi
    
    popl %edi 
    popl %esi 
    popl %ebp 
    pop %gs 
    pop %fs 
    pop %es 
    pop %ds
    
    cmpl $1, process_en_attente
    je switch_task_2
    
    cmp $1,reschedule
    je switch_task_2
    sti
    iret

1:
    movl $-10,%eax
    jmp 2b

asm_invalid_opcode:
    push %ss
    push %esp
    movl %eax,saveax
    movl 16(%esp),%eax
    pushl %eax
    movl 16(%esp),%eax
    pushl %eax
    movl 16(%esp),%eax
    pushl %eax
    movl saveax,%eax
    
    PUSHALL2
    call Invalid_Opcode

clavier:
    push %eax
    movl %cr3,%eax
    movl %eax,savecr3
    movl $0x1000,%eax
    movl %eax,%cr3
    popl %eax
    
    PUSHALL
    KERSEG
    
    call do_clavier
   
    POPALL
    iret

system_calls:

    .long do_sleep   			/* 0 */
    .long do_usleep
    .long do_getchar
    .long do_putchar
    .long do_geterreur
    .long do_console_create 		/* 5 */ 
    .long do_exec
    .long do_exit
    .long do_getpid
    .long do_getuid
    .long do_setuid			/* 10 */
    .long do_addpriority
    .long do_mount
    .long do_open
    .long do_read
    .long do_write			/* 15 */
    .long do_seek
    .long do_close
    .long do_pipe
    .long do_page_alloc
    .long do_page_partage		/* 20 */
    .long do_gettime
    .long do_uptime
    .long do_P
    .long do_V
    .long do_fcntl			/* 25 */
    .long do_nothing
    .long do_get_free_sem
fin_system_calls:
