; ce code est efface de 0 a 0x100 pour y metre les 2 TSS
BARBUXSEG = 0x1000
.org 0
zero:
jmp start
chaine:
.ascii "Hum, j'ai un peu plus de place, je vais donc passer en mode protege"
.byte 13,10,0
readsector:
.byte 0x66,0x0,0x0,0x0,0x02,0x2,10,27,0xff,0xfe
dat:
.byte 0,0,0,0,0,0,0
.byte 0,0,0
point:
.byte 46,0
adresse:
.word 0,0

start:
    
    mov ax, #BARBUXSEG
    mov ds, ax
    mov es, ax
    mov ax, #chaine
    call print
    
    
    jmp suite

suite:
    
    mov ax,#BARBUXSEG
    mov ds,ax
	
;    mov ah,#0		; attend une touche
;    int #0x16



 
    ; reprogrammation des interruption
    mov     al,#0x11               ; ! initialization sequence
    out     #0x20,al               ; ! send it to 8259A-1
    call    delay
    out     #0xA0,al                ;! and to 8259A-2
    call    delay
    mov     al,#0x20                ;! start of hardware int's (0x20)
    out     #0x21,al
    call    delay
    mov     al,#0x28                ;! start of hardware int's 2 (0x28)
    out     #0xA1,al
    call    delay
    mov     al,#0x04                ;! 8259-1 is master
    out     #0x21,al
    call    delay
    mov     al,#0x02                ;! 8259-2 is slave
    out     #0xA1,al
    call    delay
    mov     al,#0x01                ;! 8086 mode for both
    out     #0x21,al
    call    delay
    out     #0xA1,al
    call    delay


    MOV AL,#0xff            ; Interdit toute interruption
    OUT #0xa1,AL
    call delay
    
    MOV AL,#0xfb
    OUT #0x21,AL
    
    call delay
    
    
    
    lidt idt_48
    lgdt gdt_48

    cli


    call empty_8042

    movb    al, #0xD1                      ; command write
    outb    #0x64,al
    call    empty_8042

    movb    al,#0xDF                      ; A20 on
    outb    #0x60,al
    call    empty_8042
    
    
    mov ax,#1			; paf, on passe en mode proteg
    lmsw ax
    jmp flush_instr

flush_instr:

    xor    bx, bx                        ; Flag to indicate a boot
    xor    esi, esi                      ; Pointer to real-mode code
    mov    si, cs
    sub    si,#0x0020
    shl    esi,#4            

    mov ax,#0x18
    mov ds,ax

    .byte 0x66,0xea    ; on passe eip en 32 bits

code32:    
    .long 0x10200
    .word 0x10


    ret





ennd:
jmp ennd

.org 256
gdt:
.word 0,0,0,0
.word 0,0,0,0
.word 0xffff,0,0x9a00,0x00cf   	;0x10 kernel 4GB code at 0x00000000
.word 0xffff,0,0x9200,0x00cf   	;0x18 kernel 4GB data at 0x00000000
.word 0xffff,0,0xfa00,0x00cf   	;0x23 user   4GB code at 0x00000000
.word 0xffff,0,0xf200,0x00cf	;0x2b user   4GB data at 0x00000000
.word 0x0067,0,0x8901,0x0010	;0x30 TSS Systeme
;.word 0x0067,0x0080,0x8b01,0x0010	; TSS User
;.quad 0x00cf9a000000ffff  ;      /* 0x10 kernel 4GB code at 0x00000000 */
;.quad 0x00cf92000000ffff  ;      /* 0x18 kernel 4GB data at 0x00000000 */
;.quad 0x00cffa000000ffff  ;      /* 0x23 user   4GB code at 0x00000000 */
;.quad 0x00cff2000000ffff  ;      /* 0x2b user   4GB data at 0x00000000 */
			
idt_48:
.word 0,0,0

gdt_48:
.word 0x0400
.long 0x00010100


delay:
    outb    #0x80,al
    ret

empty_8042:
    push   ecx
    mov    ecx,#100000
    
empty_8042_loop:
    dec     ecx
    jz      empty_8042_end_loop

    call    delay

    inb     al,#0x64                      ;# 8042 status port
    testb   al,#1                         ;# output buffer?
    jz      no_output

    call    delay
    inb     al,#0x60                      ;# read it
    jmp     empty_8042_loop

no_output:
    testb   al,#2                     ;    # is input buffer full?
    jnz     empty_8042_loop            ;     # yes - loop

empty_8042_end_loop:
    pop    ecx
    ret






print:
    push ax
    push si
    push bx
    mov si, ax
bcl:
    cmpb [si],#0
    je fin
    mov ah,#0x0e
    mov al, [si]
    mov bl, #0
    int #0x10
    inc si
    jmp bcl

fin:

    pop bx
    pop si
    pop ax
    ret

