// Gestion des process
#include "../include/process.h"

#ifdef FAKE
#error "Ne peut tre compil avec l'option FAKE"
#endif

// Excute l'executable dans la console correspondante
int exec(char * file, int console)
{
  sys_exec(file, console);
}

// Termine proprement un processus
int quit()
{
  sys_exit();
}

// Tue un processus. Seul uid0 peut tuer un process d'uid differente
int kill(int uid)
{
  sys_kill(uid);
}

// Donne l'ordre au processus de patienter sec secondes
int sleep(int sec)
{
  sys_sleep(sec);
}

// Donne l'ordre au processus de patienter usec micro-secondes
int usleep(int usec)
{
  sys_usleep(usec);
}

// Renvoie la dernire erreur gnre par le process
int geterreur(char * erreur)
{
  sys_geterreur(erreur);
}

// Renvoie le numro du processus
int getpid()
{
  sys_getpid();
}

// renvoie l'identifiant de l'utilisateur possedant le processus
int getuid()
{
  sys_getuid();
}

// Change l'identifiant de l'utilisateur.
int setuid(int uid)
{
  sys_setuid(uid);
}

// Permet d'ajouter incr  la priorit du process
int addpriority(int incr)
{
  sys_addpriority(incr);
}


