/**********************/
/* fat12.h            */
/**********************/

/***************************************/
/* Structure vortex                    */
/***************************************/
typedef struct Vortex
{
  // Attributs gnraux
  int typefichier;
  int ID;

  // Secteur actuel
  unsigned char secteur[512];
  int CurSecteur;
  int Current; // Position actuelle dans le secteur
  int Taille; // Taille du fichier
} Vortex;

// Une entre standard de fichier

typedef struct heure
{
  char heures;
  char minutes;
  char secondes;
} heure;

typedef struct date
{
  char jour;
  char mois;
  int annee;
} date;

typedef struct fichier12
{
  char lfn;
  char nom[255];
  char ext[4];
  heure heuremodif;
  date datemodif;
  date dernieraccess;
  heure heurecreation;
  date datecreation;
  int taille;
  unsigned char attributs;
  unsigned short cluster;
} fichier12;


// Monte le fichier
// 0 -> monte le truc
// 1 -> dmonte le truc
int mount(char mode);

// Ouvre le fichier ou la directory,
// renvoie le numro du fichier
// -1: pas de disquette
// -2: disquette non FAT12
// -3: fichier non trouv
// -4: trop de fichiers ouverts
// -5: nom de fichier invalide

int openf(char * nom,Vortex ** vort);

int writef(Vortex * f, char * data, int nb);

// Lit nb caractres du fichier si celui-ci est un fichier "standard",
// lit la prochaine entre de fichier si celui-ci est un rpertoire.
// Dans ce cas, le paramtre nb n'a pas d'utilit
int readf(Vortex * f, char * data, int nb);

// Ferme proprement le fichier
void closef(Vortex ** nf);







