#include <io.h>
#include <stdio.h>
#define VIDEO ((char*) 0xb8000)

char * video = VIDEO;

void init_video()
{
    out(0x3d4,0x0b);
    out(0x3d5,1);
}

void clear(void)
{
    int i;
    char * video=VIDEO;
    for(i=0;i<2000;i++)
    {
	video[i+i]=' ';
	video[i+i+1]=0x07;
    }
}

void copy2video(char * buffer,char * couleur)
{
    int i;
    char * video=VIDEO;
    if (couleur == NULL)
	for(i=0;i<2000;i++)
	{
	    video[i+i]=buffer[i];
	}
    else
	for(i=0;i<2000;i++)
	{
	    video[i+i]=buffer[i];
	    video[1+i+i]=couleur[i];
	}
}

void printxy(char c,int x,int y,char color)
{
    char * video=VIDEO;
    int i;
    i=y*80+x;
    i*=2;
    video[i]=c;
    video[i+1]=color;
}

void cursorxy(int x,int y)
{
    short s;
    char a;
    s=(short) ((x-1)+(y-1)*80);
    out(0x3d4,0x0e);
    a=(char)(s>>8) & 0xff;
    out(0x3d5,a);
    out(0x3d4,0x0f);
    a=(char)((s) & 0xff);
    out(0x3d5,a);
}
